#ifndef __DEVICE_H_
#define __DEVICE_H_

#include <windows.h>
#include <math.h>
#include "..\_include\b181.h"

typedef BOOL (*(__stdcall pIOControl(DWORD, CDeviceID&, void*)));

#define ADC_SAMPLES_PER_CH 1000
#define DAC_SAMPLES_PER_CH 100

class CB181Device {
	BOOL DevicePresent;
	BOOL DllPresent;
	CDeviceID DeviceID;
	pIOControl* IOCONTROL;
	ULONG MemExt0[0x10000];
	ULONG MemExt1[0x10000];
	ULONG MemInt0[512];
	ULONG MemInt1[512];
	HINSTANCE dllInstall;
	CClbrInfoStruct m_ClbrInfo;
	WORD VoltageToDACCode(BYTE ch, float fValue);
	float ADCCodeToVoltage(BYTE ch, WORD nCode);
public:
	CB181Device(){DevicePresent=FALSE;DllPresent=FALSE;};
	void GetIDString(char* str);
	int PrepareDevice();  // 
	void ResetD();
	void RunD(BOOL bADC, BOOL bDAC);
	void StopD();
	void ConfigCmn();
	void ConfigADC();
	void ConfigDAC();
	void ReadFromADC(float *SignalIn);
	float ReadFromADCDirect(); // this function returns only Ch1 code
	void WriteToDAC(float *SignalOut);
	void WriteToDACDirect(float fValue);
	BOOL ReadStatus(CmnStatusStruct& status);
	void CloseDevice();
};
#endif//__DEVICE_H_
