#ifndef __UNILPTX_H__
#define __UNILPTX_H__

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the UNILPTX_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// UNILPTX_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.

#ifdef UNILPTX_EXPORTS
#define UNILPTX_API __declspec(dllexport) 
#else
#define UNILPTX_API __declspec(dllimport)
#endif

#define UNILPTX_CALL __stdcall

// This class is exported from the UniLPTX.dll

#include "DevTypes.h"

namespace UNILPTDrv
{
// Lock/UnLock device
	CDeviceID* UNILPTX_CALL LockDevice(CDeviceType DeviceType);
	//     ,    
	//    DeviceType  NULL,    
	bool UNILPTX_CALL UnLockDevice(CDeviceID& DeviceID);
	//  ,     LockDevice.

// Data access
	BOOL UNILPTX_CALL WriteToEPROM(const CDeviceID& DeviceID, int nStartAddr, int nCount, void* pData);
	//  (!)  (. )  ,    !
	BOOL UNILPTX_CALL ReadFromEPROM(const CDeviceID& DeviceID, int nStartAddr, int nCount, void* pData);
	//    (. )  

	void UNILPTX_CALL WriteToInterface(const CDeviceID& DeviceID, UCHAR nInterfaceReg, UCHAR nRegData);
	//     
	UCHAR UNILPTX_CALL ReadFromInterface(const CDeviceID& DeviceID, UCHAR nInterfaceReg);
	//     

	void UNILPTX_CALL WriteToDevice(const CDeviceID& DeviceID, char nInternalAddr, CRegType RegType, void* pData, int nCount);
	//     (  TRRRTWWW).  , . prog manual   
	void UNILPTX_CALL WriteToDeviceEx(const CDeviceID& DeviceID, UCHAR nInternalAddr, CRegType RegType, void* pData, int nCount);
	//     (  WWWWWWWW).  , . prog manual   
	void* UNILPTX_CALL ReadFromDevice(const CDeviceID& DeviceID, char nInternalAddr, CRegType RegType, void* pData, int nCount);
	//     (  TRRRTWWW).  , . prog manual   
	void* UNILPTX_CALL ReadFromDeviceEx(const CDeviceID& DeviceID, UCHAR nInternalAddr, CRegType RegType, void* pData, int nCount);
	//     (  RRRRRRRR).  , . prog manual   

// PLD Configuration
	bool UNILPTX_CALL AlteraPLDProgramming(CDeviceID& DeviceID,  HMODULE hModule, LPCTSTR lpResName);
	const LPCTSTR lpAlteraResourceType = "AlteraPLDData";
	// Exceptions
	const int ELPTInit = 0xf000;
	const int EResourceFindFailed = 0xf001;
	const int EResourceLoadFailed = 0xf002;
	const int EResourceLockFailed = 0xf003;
	const int EPLDProgError = 0xf004;

// Debug
	bool UNILPTX_CALL IsLogging();
	void UNILPTX_CALL StartLog(LPCTSTR filename = "_UniLPTX.log");
	void UNILPTX_CALL EndLog();
	void UNILPTX_CALL AddToLog(LPCTSTR lpStr);
}
#endif