#ifndef ____UNILPTX_H__
#define ____UNILPTX_H__

#ifndef UNILPTX_API
#define UNILPTX_API __cdecl
#endif

// Hardware connection modes configuration

UNILPTX_API int __GetModesCount();
// returns number of supported hardware connection modes
// valid mode indexes are 0 to __GetModesCount()-1

UNILPTX_API BOOL __GetModeInfo(	int nIndex,					// [in] requested mode index
							   LPTSTR lpszTitle,			// [in, out] dest char buffer for mode title
							   int MaxSize,					// [in] dest buffer size
							   BOOL* pbEnabled = NULL,		// [in,out] mode status
							   int* pnPortNumber = NULL);	// [in,out] port number restrictions
// assigns requested mode title and status (TRUE - enabled, FALSE - disabled)
// mode status stored in "HKCU\Software\UniPro\Hardware Interfaces\%ModeTitle%\Mode Enabled" (DWORD) registry value
// returns TRUE if success, FALSE if nIndex is invalid or MaxSize is not enough for mode title

UNILPTX_API BOOL __EnableMode (	int nIndex /*[in] requested mode index*/,
							   BOOL bEnable /*[in] mode status*/,
							   int nPortNumber = -1);	// [in] valid port number
// -1 (default) no changes
// =0 no restrictions (delete registry value if it exists)
// >0 port number to initialize (restrict to only one port number)
// creates (or updates existing) mode settings in registry
// returns TRUE if all operations completed successfully, otherwise FALSE.

UNILPTX_API int __GetActiveMode();
// returns current hardware connection mode index (returns -1 if mode is not initialized)

UNILPTX_API int __SetMode(int nIndex /*[in] requested mode index*/);
// lets to switch to new (or re-init current) hardware connection mode
// function	deinitializes current mode (if initialized);
//			tries to init requested mode;
//			tries to init current mode if requested mode init failed (3 times);
// returns initialized mode index (-1 if init failed)

#endif// ____UNILPTX_H__